#define pi 3.141592654
#define starnum 499
#define sphere_starnum 499
#define xres vga_getxdim()
#define yres vga_getydim()
#define random (double)rand()/RAND_MAX
#define __0player 0
#define __1player 1
#define __2player 2

typedef float angletable[3600];
typedef struct {
	float x,y,vx;
	int color;
} mover[starnum+1];
typedef struct {
	int wx,wy,rad;
	int color;
} spheremover[sphere_starnum+1];
typedef struct {
	float x,y,vx,vy;
} gameball;
typedef struct {
	float ax,ay;
} level;
typedef struct {
	int x,y,l,points;
} gamepad;


angletable sinus,cosin;

extern void init_fast_angle_functions(void);
extern void load_tga(char*,int,int,int,int);
extern void fadescreen(void);
extern void draw_mousecursor(int,int);
extern void init_starfield(mover);
extern void background_starfield(mover,GraphicsContext*);
extern void init_sphere(int,int,spheremover);
extern void background_sphere(spheremover,GraphicsContext*);
extern gameball init_gameball(float,float,float,float);
extern gameball ball_movebasic(gameball);
extern gameball ball_moveadvanced(gameball,level*);
extern level *load_levelmap(char*);
extern gamepad calcpad(gamepad,int,gameball);
extern void calc_situation(gamepad*,gamepad*,gameball*); 