#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <vgagl.h>
#include <vga.h>

#define gamma 80
#define xres vga_getxdim()
#define yres vga_getydim()
#define sqr(x) ((x)*(x))

void main(void)  {
typedef struct  {
	float x,y;
} _;

FILE *file_p;
_ field;
int x,y;
float rng,acc;
_ *ff_p,*fff_p;

	vga_init();
	vga_setchipset(3);
	vga_setmode(G640x480x64K);
	gl_setcontextvga(G640x480x64K);
	
	ff_p = fff_p = malloc(640*480*sizeof(_));
	if (ff_p == NULL)	{ 
		printf("can't allolcate memory\n");
		exit(0);	} 
	
	for (x=0; x<xres; x++)
	  for (y=0; y<yres; y++)  {
		rng = 4 + sqrt( sqr(xres/2-x)+sqr(yres/2-y) );
		acc=gamma/rng;
		ff_p->x = (float)(acc/rng*(xres/2-x));
 		ff_p->y = (float)(acc/rng*(yres/2-y));
	  	ff_p++;
	  }
	
	ff_p = fff_p;
	for (x=0; x<xres; x++)
	  for (y=0; y<yres; y++)  {
		gl_setpixel(x,y,100*(int)sqrt(sqr(ff_p->x)+sqr(ff_p->y)));
	  	ff_p++;
	  }
	
	file_p = fopen("./levels/level1.map","w");
	  fwrite(fff_p,sizeof(_),640*480,file_p);	
	fclose(file_p);
	
	while (vga_getkey()==0);	  
}
